How to Query the API
In order to retrieve the content from your repository, you will need to query the repository API. When you create your query you will specify exactly what it is you are looking for. You could query the repository for all the documents of certain type or retrieve the one specific document you need.
Let’s take a look at how to put together queries for whatever case you need.
Check out the Integrating with an existing Javascript project page to learn how to get set up to query documents.
When retrieving content from your Prismic repository using javascript, here's what a typical query looks like:
const Prismic = require('@prismicio/client')
Prismic.client("https://your-repository-name.cdn.prismic.io/api/v2", { req: req }).then(function(api) { return api.query(
Prismic.Predicates.at('document.type', 'blog-post'),
{ orderings : '[my.blog-post.date desc]' }
);
}).then(function(response) {
// response is the response object, response.results holds the documents
});
This is the basic format of a query. In the query you have two parts, the Predicate and the options.
You can omit the `req` parameter if you're doing your queries on the client side (React.js, Vue.js, Angular.js, etc)
Using the API server-side
It comes handy to use the `initAPI` helper function if you're doing your query from the server side (like in Node.js)
Should I call `initApi` on every query?
The `initAPI` call returns the API object and is required to get the latest version of your content. You should call `initApi` to retrieve the API object on every request, page, or screen. It is recommended to assign the API object to a variable, and use it for all queries of the same screen.
Why does `initApi` call requires a `req` parameter?
Prismic has the capacity to do unlimited different preview sessions for different drafts or releases. To offer this and other powerful functionalities, Prismic uses a cookie that it assigns to the `req` object.
Simply providing `req` to the API enables unlimited previews and other upcoming powerful features.
You can omit the `req` parameter if you're performing your queries for the client-side (ex: React.js, Angular.js). The API will be able to retrieve the required token on its own.
Predicates are a powerful way to query your content. In the above example we had the following predicate:
You will find a list and description of all the available predicates on the Query Predicates Reference page.
Prismic.Predicates.at('document.type', 'blog-post')
The predicate(s) will define which documents are retrieved from the content repository. The first part, "document.type" is the path, or what the query will be looking for. The second part the predicate in the above example is "blog-post" this is the value that the query is looking for.
You can combine more than one predicate together to refine your query. You just need to put all your predicates into a comma-separated array like the following example:
[ Prismic.Predicates.at('document.type', 'blog-post'),
Prismic.Predicates.at('document.tags', ['featured']) ]
This particular query will retrieve all the documents of the "blog-post" type that also have the tag "featured".
In the second part of the query, you can include the options needed for that query. In the above example we had the following options.
{ orderings : '[my.blog-post.date desc]' }
This specifies how the returned list of documents will be ordered. You can include more than one option, by comma separating them as shown below:
{ pageSize : 10, page : 2 }
const Prismic = require('@prismicio/client');
Prismic.client("https://your-repository-name.cdn.prismic.io/api/v2").then(function(api) {
return api.query(
[ Prismic.Predicates.at('document.type', 'blog-post'),
Prismic.Predicates.at('document.tags', ['featured'])],
{ pageSize : 25, page : 1, orderings : '[my.blog-post.date desc]' }
);
}).then(function(response) {
// response is the response object, response.results holds the documents
});
Whenever you query your content, you end up with the response object stored in the defined variable. In this case the response object is stored in the response variable.
When querying a Prismic repository, your results will be paginated. By default, there are 20 documents per page in the results. You can read more about how to manipulate the pagination in the Pagination for Results page.

Fetch Data

Make queries to the Prismic API to get content into your React application.

In this article, you’ll learn how to perform different queries to the Prismic API to get content in your React application.

Queries are performed using hooks and the Prismic client registered in <PrismicProvider>.

Here’s a basic query that fetches the first Prismic document you’ve created.

import { PrismicRichText, useFirstPrismicDocument } from "@prismicio/react";

function App() {
  const [document] = useFirstPrismicDocument();

  return (
    <div>
      {document && <PrismicRichText field={document.data.example_rich_text} />}
    </div>
  );
}

Below are the most commonly-used query helper hooks and their use cases.

Fetch a singleton page

In Prismic, you can create a singleton page type to store pages with one instance, such as a homepage or contact page.

To query a singleton, use the useSinglePrismicDocument hook with the API ID of the singleton custom type.

For example, here we are querying for the only document of the type homepage.

const [document] = useSinglePrismicDocument("homepage");

Fetch a menu document

To query a menu document, use the useSinglePrismicDocument hook with the API ID of the menu custom type.

For example, here we are querying for the only document of the custom type menu.

const [menu] = useSinglePrismicDocument("menu");

Fetch one page from a page type

On repeatable documents, we recommend adding a UID field — a unique identifier. Prismic formats each document’s UID so it is URL-friendly and unique to its custom type.

To query a specific document of a given custom type, like a blog post, use the usePrismicDocumentByUID hook with the UID and the API ID of the custom type.

For example, here we are querying for a post document with a UID of my-first-post.

const [document] = usePrismicDocumentByUID("post", "my-first-post");

Fetch all pages from a page type

To query all pages of a given custom type, like for a posts page, use the useAllPrismicDocumentsByType hook with the UID and the API ID of the custom type.

This method may perform multiple network requests and returns an array containing all matching documents from the repository.

For example, here we are querying for all documents of the custom type article.

const [documents] = useAllPrismicDocumentsByType("article");

Fetch all documents

For best performance, we do not recommend querying all Prismic documents. Instead, we recommend querying documents by type using useAllPrismicDocumentsByType.

Fetch pages by language

Prismic allows you to publish your content in different languages. By default, the API will return content in your master language. To get content in a different language, add an options object with a lang option and a locale code.

Here’s an example of how to query the document of the type homepage in French (fr-fr).

import { useSinglePrismicDocument } from "@prismicio/react";

function App() {
  const [homepage] = useSinglePrismicDocument("homepage", {
    lang: "fr-fr",
  });

  // Use `homepage` in your component's return value
}

Display a loading message

Every query hook returns its loading status alongside the query result. You can access the status by destructuring it from the second element of a hook’s return value.

Here’s an example using a hook’s status to display a loading message.

import { usePrismicDocumentByUID } from "@prismicio/react";

function App() {
  const [page, { state }] = usePrismicDocumentByUID("page", "hello-world");

  return (
    <div>
      {state === "loading" ? (
        <p>Loading…</p>
      ) : (
        page && <p>{page.data.example_field}</p>
      )}
    </div>
  );
}